// NVNC - .NET VNC Server Library
// Copyright (C) 2012 T!T@N
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


using System;
using System.Drawing;

namespace NVNC.Encodings
{
    /// <summary>
    /// Implementation of CopyRect encoding.
    /// </summary>
    public sealed class CopyRectRectangle : EncodedRectangle
    {
        public CopyRectRectangle(RfbProtocol rfb, Framebuffer framebuffer, int[] pixels, Rectangle rectangle)
            : base(rfb, framebuffer, rectangle, RfbProtocol.Encoding.COPYRECT_ENCODING)
        { }

        // CopyRect Source Point (x,y) from which to copy pixels in Draw
        Point source;

        public override void Encode()
        {
            //source = new Point();
            pwriter.Write((ushort)rectangle.X);
            pwriter.Write((ushort)rectangle.Y);
        }
    }
}